// Open Source, private use only!
// Python Stellwerk nach DiMo (Digitale Modellbahn)
// EW kann Gleissperre sein
// Autoren F. Bollow, G. Krumm (LocoNet-Adaption)

//#define LOCONET

#define VERSION "STWTX01"    
// Version STWTXxx: Touchscreenplatine für XBus
// Version STWTLxx: Touchscreenplatine für LocoNet
// Version STWPXxx: Fahrpultplatine für XBus
// Version STWPLxx: Fahrpultplatine für LocoNet

#ifdef LOCONET
#include <LocoNet.h>
#define LN_TX_PIN 2         //LocoNet-Transmit-Pin: fuer Fahrpultplatine 2, fuer Touchscreenplatine 6
#define WDELAY    false     //Verlaengerung der Schaltzeit ueber Zentrale = true
lnMsg        *LnPacket;

#else
#include "XpressNetMaster.h"
XpressNetMasterClass XpressNet;

                            //Max485 Busdriver Send/Receive-PIN
#define XNetSRPin     5     // Fuer Touchscreenplatine
//#define XNetSRPin   13     // fuer Fahrpultplatine 
#endif                      

// void SetTrntPos(uint16_t Address, uint8_t state, uint8_t active); // Aenderung der Weichenlage
#define XWAIT  1100
#define XWLONG 2000
#define WAIT   1000

#define RQUEST 4            // getPowerState()
uint8_t PScnt  = RQUEST;

uint8_t NewState     = 0;   // Anlagenzustand an Rasp
uint8_t NewStateFlag = 0;

// -------------------------------------------------------------------------
void setup() {
#ifndef LOCONET
  pinMode(XNetSRPin, OUTPUT);
  digitalWrite(XNetSRPin, LOW); // MAX485 Output: High Z
#endif

  Serial.begin(9600);
  Serial.println(VERSION);
  Serial.print("XWAIT:");Serial.println(XWAIT);
  Serial3.begin(9600);
  Serial3.print("Start ");Serial3.println(VERSION);

#ifdef LOCONET
  LocoNet.init(LN_TX_PIN);                //Initialisierung LocoNet
#else
  XpressNet.setup(Loco128, XNetSRPin);    //Initialisierung XNet-Bus
#endif
} // setup()
// -------------------------------------------------------------------------


int  i = 0;
char y;
#define ADIM 80
char marray[ADIM] = "";
char sarray[ADIM] = "";

#define FDIM   20
int16_t Fweg[FDIM] = {0};
#define DEFDIM 10

unsigned long aktuellZeit = 0;
unsigned long davorZeit   = 0;


unsigned long aktuellXZeit = 0;
unsigned long davorXZeit   = 0;

unsigned long StartTime = 0;
unsigned long StopTime  = 0;
unsigned long DiffTime  = 0;

#define GRD_GRN  1
#define RND_ROT  0

uint16_t Wnum  = 8;
uint8_t  WLage = RND_ROT;

int cnt  = 0;
int cnti = 0;
int xcnt = 0;
int anzW = 0;

#define  XQDIM 256
int16_t  XBusQueue[XQDIM] = {0};
uint16_t WRptr            =  0;
uint16_t RDptr            =  0;
#define  PTRMSK            XQDIM-1  // 64 Bytes, Maske 0x3F

int16_t QWnum = 0;

int16_t num = 0;

char *stra[] = {"Msg. 0","Msg. 1","Msg. 2","Msg. 3"};  // 7 Zeichen
char *strb[] = {"_0Power ok","_1Nothalt","_2Notaus","_3other"};

//------------------------------------------------------
int parserF(char *stri) {
int  slen            = strlen(stri);
int  cnt             = 0;
int  j               = 0;
char tstr[DEFDIM]    = {""};
int  val             = 0;
uint8_t WeichenIndex = 0;

for (int i = 2; i < slen; i++) { // skip "F;"
  if (stri[i] == ';') { 
      tstr[j] = '\0';
      j = 0;
      val = atoi(tstr);     
      Fweg[WeichenIndex] = val;           
      WeichenIndex++;        
      cnt++;
      } // if 
  else {
    tstr[j] = stri[i];   // Teilstring aufbauen
    j++;
    }
} // for

return cnt;  
} // parserF()


void ListFw(int WLagen) {
for(int i = 0; i < WLagen; i++) {
   Serial.print(Fweg[i]); Serial.print(' ');
   WRqueue(Fweg[i]);
   } //for
Serial.println();
}

uint16_t RDqueue(void) {
int16_t dat = 0;

if (WRptr != RDptr) {
   dat = XBusQueue[RDptr];
   RDptr++; RDptr = RDptr & PTRMSK;
   }
//if (WRptr == 12) LQueue();
return dat;
} // RDqueue()


void WRqueue(int16_t indat){
     XBusQueue[WRptr]=indat;
     WRptr++; WRptr = WRptr & PTRMSK;     
  
} // WRqueue()


void EWeiche(int Adr) {

Serial.print(",>X:");Serial.print(Adr);
WRqueue(Adr);  
} // EWeiche()

#ifdef LOCONET
// Some turnout decoders (DS54?) can use solenoids, this code emulates the digitrax
// throttles in toggling the "power" bit to cause a pulse
void requestSwitch(int address, byte dir, byte wdelay) {
    LocoNet.requestSwitch(address, 1, dir);
    updateLN();
    if (!wdelay) LocoNet.requestSwitch(address, 0, dir);
}

void updateLN() {
  LnPacket = LocoNet.receive(); //permanent update the library
  if (LnPacket) LocoNet.processSwitchSensorMessage(LnPacket);
}
#endif

void LQueue(void) {
 for(int k=0;k<12;k++) {
  Serial.print(' ');Serial.print(XBusQueue[k]);
 }
 Serial.println(); 
}

int lastAdr = 0;
int XWvar   = 0;
int delcnt  = 0;

void XBout(int QWnum) {
if (QWnum) {
          if (QWnum < 0) {
              QWnum= abs(QWnum);
              WLage = RND_ROT;
              }
          else {
              WLage = GRD_GRN;
              }
#ifdef LOCONET
      requestSwitch(QWnum, WLage, WDELAY);
#else
      XpressNet.SetTrntPos(QWnum-1,WLage,1);
#endif
      StopTime = millis();  
      DiffTime = StopTime - StartTime;
      Serial.print(' ');Serial.println(DiffTime);
      lastAdr=QWnum;
      }
} // XBout()

//------------------------------------------------------

void loop() {

char s[20] ="";

#ifdef LOCONET
updateLN();
#else
XpressNet.update(); // mandatory: permanent update the library
#endif

aktuellZeit = millis();
if (aktuellZeit - davorZeit > XWLONG) {
   davorZeit = aktuellZeit;
   if (NewStateFlag) {
      if (NewState > 2) NewState = 3;
      Serial3.println(strb[NewState]);
      NewStateFlag = 0;
      }
   else {
       cnt++;  
       if (!(cnt % 10)) {
          Serial3.println(stra[cnti]);
          cnti++; cnti = cnti & 0x03;
          }
       else Serial3.println(cnt);
       }
} // millis() Long


aktuellXZeit = millis();
if (aktuellXZeit - davorXZeit > WAIT) {
   davorXZeit = aktuellXZeit;
   if (delcnt) {
       delcnt--;
       Serial.print('-');
       if (delcnt == 0) {
           XBout(QWnum);   // verzögerte Ausgabe der 2. gleichen Adr.
           Serial.print('v');
           }
       }
   else { 
        QWnum = RDqueue();
        if (QWnum) {
            if (abs(QWnum) != lastAdr) {   // Adressen ungleich, Ausgabe   
                XBout(QWnum);   
                Serial.print('.');        
                }  
             else {                       // gleich, 2.Adr mit delay ausgeben     
                  delcnt=3;    
                  }
         }
         else { // keine Schaltaufgabe, Info XBus anfordern
              PScnt--;
              if (PScnt == 0) {
                 PScnt = RQUEST;
                 //getPowerState();
                 }            
              }
      }
} // millis()  

 
if (Serial3.available() > 0)  {   
     y = Serial3.read();     
     sarray[i] = y;                     // char einsammeln
     i++;
     if (i > (ADIM-5)) {
         Serial.println("near overflow, i=0");
         i=0;
         }
     if (y == 0x0A) {           // LF         
         sarray[i]= '\0';         
         switch (sarray[0]) {
         case 'F': 
             Serial.print(sarray);
             anzW = parserF(sarray);  
             sarray[0] = '\0';
             i=0; 
             if (anzW) ListFw(anzW);
            break;
        case 'S':             
        case 'B':             
        case 'R':
             Serial.print(sarray);
             sarray[0] = '\0';
             i=0;
            break;    
        default:             
              num = atoi(sarray);    
              Serial.print("R>Adr:");Serial.print(num);
              StartTime = millis();  // Stellbefehl, Empfang
              EWeiche(num);
              sarray[0] = '\0';
              i=0; 
             break;
         } //switch
     } // LF 
  } // if serial avail. 
 
} // loop()
// -----------------------------------------------------------------

#ifdef LOCONET
void notifyPower(uint8_t State) {
#else
void notifyXNetPower(uint8_t State) {
#endif

Serial.print("State:");Serial.println(State);  
NewState     = State;
NewStateFlag = 1;
}
